/*
   Tela 1.0: Programma di Tela a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.swing.*;
import java.awt.geom.*;
import java.awt.*;
import java.awt.event.MouseWheelListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;


public class Graph extends JPanel {
 
public Punto p[][],p2[][];
private int s,d,nNero,nBianco,i,j,mosse,w,h;
public Punto selP; 
private int state,Nrem,remI,remJ;
private boolean mode,rem,active;
public boolean imgPedine,neroPc,biancoPc;
private Mosse m;      
private static Image Pnero;
private static Image Pbianco;

  	public Graph(){
  		Pbianco=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("bianco.png"));
		Pnero=Toolkit.getDefaultToolkit().getImage(this.getClass().getResource("nero.png"));

 		Mouse mouse=new Mouse();
  		m=new Mosse();
  		this.addMouseListener(mouse);
  		this.addMouseMotionListener(mouse);
  		neroPc=biancoPc=false;
  		imgPedine=true;
  		selP=new Punto();
  
  MediaTracker tracker = new MediaTracker(this);
	    
	    tracker.addImage(Pnero, 0);	
	    tracker.addImage(Pbianco, 0);
try{	    
	    tracker.waitForID(0);
	}catch(Exception e){}
        
         nNero=nBianco=mosse=Nrem=0;
         mode=rem=false;
         p=new Punto[8][3];
         p2=new Punto[9][2];        
         for (int j=0;j<3;j++)
         for (int i=0;i<8;i++)
         p[i][j]=new Punto();

         for (int i=0;i<9;i++){         
         p2[i][0]=new Punto();         
         p2[i][1]=new Punto();
         p2[i][0].setState(Punto.NERO);
         p2[i][1].setState(Punto.BIANCO);                   
         }
         
         this.setDim(400,400);
         
        i=j=-1;
        remI=remJ=-1;
        state=Punto.BIANCO;
        active=true;                   		
  		}
  
  public void reset(){
  	
         nNero=nBianco=mosse=Nrem=0;
         mode=rem=false;  	
  	
  	     for (int j=0;j<3;j++)
         for (int i=0;i<8;i++)
         p[i][j].setState(Punto.VUOTO);

         for (int i=0;i<9;i++){         
         p2[i][0].setState(Punto.NERO);
         p2[i][1].setState(Punto.BIANCO);                   
         }
  	   
  	selP.setState(Punto.VUOTO);   
  	    i=j=-1;
        remI=remJ=-1;
        state=Punto.BIANCO;
        active=true;    	
  	    m.clear();
  	}
  	
  public void annulla(){
  	
    Mosse.Mossa ms=m.getLastAndRemove();
   
    if (ms==null) return;
   
    if (!active) active=true;
   
    if (ms.rem){
    	
    	int col;
    	if (ms.color==Punto.BIANCO){
    	   col=Punto.NERO;
    	   nNero++;}
    	   else{ col=Punto.BIANCO;
           nBianco++;}
    	
    	p[ms.fromI][ms.fromJ].setState(col);
    	Nrem++;
    	
    	if (!rem) invState();
    	
    	rem=true;
    	}
    else
    {
    	  
    if (ms.mode){
    	
        p[ms.fromI][ms.fromJ].setState(ms.color);
        p[ms.toI][ms.toJ].setState(Punto.VUOTO);
      
       invState();	  
    	}else{
    		
        p2[ms.fromI][ms.fromJ].setState(ms.color);
        p[ms.toI][ms.toJ].setState(Punto.VUOTO);
        
if (Punto.BIANCO==ms.color)
    nBianco--;
else 
    nNero--; 
      		
    invState();	}
    
    mosse--;
    if (rem){
    rem=false;
    Nrem=0;
    invState();}   
    }
   	
   	mode=ms.mode;
   	  	
  	}	
  
	
  
  public void setDim(int w,int h){
  	     
  	     int shiftw=0;
   	     int shifth=0; 	     
  	     if (w!=h){
  	     	if (w>h){ shiftw=(w-h)/2;
  	        s=h/8;}
  	     	else{ shifth=(h-w)/2;
  	        s=w/8;}
  	     	}
  	     else s=w/8;
  	      
  	    this.w=w;
  	    this.h=h;
  	     
  	     d=s/2;
  	     int x,y,b,n;
  	     
  	     for (int j=0;j<3;j++){
         
         if (j==0) b=s;
         else if (j==1) b=2*s;
         else b=3*s;
         
         n=4*s-b;
         x=y=b;
  
         
         for (int i=0;i<8;i++){
         
        
                 
         p[i][j].setPos(x,y);

         if ((x<b+n+n)&&(y==b)) x=x+n;
         else if ((x==b+n+n)&&(y<b+n+n)) y=y+n;
         else if ((x>b)&&(y==b+n+n)) x=x-n;
         else if ((x==b)&&(y>b)) y=y-n; 
          
               }
               
               }
          
          n=7*d/10;
          y=n+d/2;

    
         for (int i=0;i<9;i++){
                 	
         p2[i][0].setPos(d/2,y);
         p2[i][1].setPos(s*8-d/2,y);              
       
         y=y+n+d;
         
                 	}       
        
        
         for (int j=0;j<3;j++)
         for (int i=0;i<8;i++)
             p[i][j].translate(shiftw,shifth);
         for (int i=0;i<9;i++){
         p2[i][0].translate(shiftw,shifth);
         p2[i][1].translate(shiftw,shifth);

         }   
  	
  	    }

  public void paintComponent(Graphics g){
   	   	super.paintComponent(g);
   	Graphics2D g2=(Graphics2D) g;
   	


    if(active){
   this.drawTav(g2);   

    if (selP.getState()!=Punto.VUOTO)
       drawPedina(g2,selP.X(),selP.Y(),d,selP.getState(),w,h,this);
      }
      else {
      	String win;
      	if (0!=contaMovibili()){
       	if (state==Punto.BIANCO) win="HA VINTO IL BIANCO";
      	else win="HA VINTO IL NERO";
      }else {
       	if (state==Punto.BIANCO) win="HA VINTO IL NERO";
      	else win="HA VINTO IL BIANCO";
      	}
      	setFont(new Font("",Font.PLAIN,(int)(w/20)));
      	g2.drawString(win,w/4,h/2);
    	   	   	System.out.println(w/20+" "+w+" "+h);      
      	}
   }

private void drawTav(Graphics2D g2){
	     

         g2.setColor(Color.black);
         for (int j=0;j<3;j++){
         g2.drawLine(p[0][j].X(),p[0][j].Y(),p[2][j].X(),p[2][j].Y());
         g2.drawLine(p[4][j].X(),p[4][j].Y(),p[6][j].X(),p[6][j].Y());
         g2.drawLine(p[0][j].X(),p[0][j].Y(),p[6][j].X(),p[6][j].Y());
         g2.drawLine(p[2][j].X(),p[2][j].Y(),p[4][j].X(),p[4][j].Y());
         }
         
         g2.drawLine(p[1][0].X(),p[1][0].Y(),p[1][2].X(),p[1][2].Y());
         g2.drawLine(p[5][0].X(),p[5][0].Y(),p[5][2].X(),p[5][2].Y());
         g2.drawLine(p[3][0].X(),p[3][0].Y(),p[3][2].X(),p[3][2].Y());
         g2.drawLine(p[7][0].X(),p[7][0].Y(),p[7][2].X(),p[7][2].Y());

         for (int j=0;j<3;j++)
         for (int i=0;i<8;i++){
         g2.setColor(Color.lightGray);
         g2.fillOval(p[i][j].X()-d/2,p[i][j].Y()-d/2,d,d);
         g2.setColor(Color.black);
         g2.drawOval(p[i][j].X()-d/2,p[i][j].Y()-d/2,d,d);         
         
         if (!((mode)&&(this.i==i)&&(this.j==j))){
         drawPedina(g2,p[i][j].X(),p[i][j].Y(),d,p[i][j].getState(),w,h,this);
         
         if ((remI==i)&&(remJ==j)) 
         drawRem(g2,p[i][j].X(),p[i][j].Y(),d);
      
        }
        }
	 
	 for(int i=0;i<9;i++){
 if (!((!mode)&&(this.i==i)&&(this.j==0)))
 drawPedina(g2,p2[i][0].X(),p2[i][0].Y(),d,p2[i][0].getState(),w,h,this);	
 if (!((!mode)&&(this.i==i)&&(this.j==1)))
 drawPedina(g2,p2[i][1].X(),p2[i][1].Y(),d,p2[i][1].getState(),w,h,this);
	 	}
	     
	}

   public static void drawRem(Graphics2D g2,int x,int y,int d)
   {
   	g2.setColor(Color.red);
   	
   	g2.drawLine(x-d/2,y-d/2,x+d/2,y+d/2);
  	g2.drawLine(x-d/2,y+d/2,x+d/2,y-d/2);  	
   	}

   public static void drawPedina(Graphics2D g2,int x,int y,int d,int state,int w,int h,Graph p){
   	
   	if ((x<0)||(y<0)||(x>w)||(y>h)) return;
   	
      if (state==Punto.BIANCO){
      	
      	if (p.imgPedine) g2.drawImage(Pbianco,x-15,y-15,p);
      	else{
         g2.setColor(Color.white);
         g2.fillOval(x-d/2+1,y-d/2+1,d-2,d-2);
         g2.setColor(Color.black);
         g2.drawOval(x-d/2+1,y-d/2+1,d-2,d-2);
         g2.drawOval(x-d/6,y-d/6,d/3,d/3);        
         g2.drawOval(x-d*2/6,y-d*2/6,d*2/3,d*2/3);    
   }  
         
         	}
         	
      if (state==Punto.NERO){ 
     
     if (p.imgPedine) g2.drawImage(Pnero,x-15,y-15,p);
      	else{
      	 g2.setColor(Color.black);
         g2.fillOval(x-d/2+1,y-d/2+1,d-2,d-2);
         g2.setColor(Color.white);
         g2.drawOval(x-d/6,y-d/6,d/3,d/3);        
         g2.drawOval(x-d*2/6,y-d*2/6,d*2/3,d*2/3); 
      }

          
         	}
   	
   	}
   
   private boolean checkPos(int x,int y){
   	
int st;

if (mode) st=checkPunto(x,y);
else st=checkPunto2(x,y);
if (st==-1) return false;

if (st==state) return true;
	
return false;
   	}



   private boolean checkMove(int tox,int toy){
   	
   	
int st,i1,i2,j1,j2;

st=checkPunto(tox,toy);
if (st==-1) return false;

    i2=getPuntoIJ(tox,toy).x;
    j2=getPuntoIJ(tox,toy).y;

if (mode){
	j1=j;
	i1=i;
	}else i1=j1=-1;
   
   	return isValidMove(i1,j1,i2,j2);
   	}
   
   private int getCol(int x,int y){
   	int ret;
   	ret=checkPunto(x,y);   	
   	if (ret==-1) ret=checkPunto2(x,y);
   	if (ret==-1) return Punto.VUOTO;
   	return ret;
   	}
   
   public boolean isPcPlayer(){
   	
   	if (((state==Punto.BIANCO)&&(biancoPc))||
   	    ((state==Punto.NERO)&&(neroPc)))
	    return true;
	    else return false;
	    
   	}
   	
   	public boolean isActive(){
   		return active;}
 
    public boolean is3Pedine(){
    	
    	if (!mode) return false;
    	 
    	 if (((state==Punto.BIANCO)&&(nBianco==3))||
    	     ((state==Punto.NERO)&&(nNero==3))) return true;
    	     
    	     return false;
    	}
   
   private boolean isValidMove(int i1,int j1,int i2,int j2){
        	
     	if (p[i2][j2].getState()!=Punto.VUOTO) 
     	return false;
     	
     	if ((i2==j2)&&(i2==-1)) return false;
     	
     	if (((i1==j1)&&(i1==-1))||((nNero==3)&&(p[i1][j1].getState()==Punto.NERO)||(nBianco==3)&&(p[i1][j1].getState()==Punto.BIANCO)))
     	return true;
     	
     	
     	if ((i1==i2)&&((i1+1)%2==0)&&(j1!=j2))
     	   {
     	   	if ((j1==j2+1)||(j1==j2-1))
     	   	return true;
     	   	}
     	   	
     	if (j1==j2)
     	   {
     	   	if ((i1==i2+1)||(i1==i2-1)||((i1==0)&&(i2==7)||(i2==0)&&(i1==7)))
     	   	return true;
     	   	}
     	
     	return false;}

    public void move(int fromI,int fromJ,int toI,int toJ){

    	i=fromI;
    	j=fromJ;
        
        moveToxy(p[toI][toJ].X(),p[toI][toJ].Y());
        
    	}


    private void moveToxy(int tox,int toy){

 		p[getPuntoIJ(tox,toy).x][getPuntoIJ(tox,toy).y].setState(this.state);
    
       if (mode){
        rem1(i,j);
       	}else{
 if (Punto.BIANCO==state)
    nBianco++;
 if (Punto.NERO==state)
    nNero++;	
       	rem2(i,j);	
        
        }
        
        m.addMove(i,j,getPuntoIJ(tox,toy).x,getPuntoIJ(tox,toy).y,state,mode);
        
        int nr=isPTrig(getPuntoIJ(tox,toy).x,getPuntoIJ(tox,toy).y);
        if (nr!=0) {
        	Nrem=nr;
        	rem=true;
        	int free=contaLibere();
        	if (free<Nrem) Nrem=free;
        	
        	if (free==0){
        		rem=false;
        		invState();
        		}
        	 
        	if ((free!=0)&&(mode)&&(((state==Punto.BIANCO)&&(nNero==3))||((state==Punto.NERO)&&(nBianco==3)))){
        		active=false;   
        		} 

        	}
        else  invState();
	
        remSelPos();

if ((!rem)&&(mode)&&(0==contaMovibili())) 
    active=false; 
    
        mosse++;
    	if (mosse==18) mode=true;	
     	}      
    
    private int contaLibere(){
    	
    	int tot=0,st=0;
           	
      if (state==Punto.BIANCO) st=Punto.NERO;
 else if (state==Punto.NERO) st=Punto.BIANCO;
    	
    	 for (int j=0;j<3;j++)
         for (int i=0;i<8;i++)
         if ((p[i][j].getState()==st)&&(isRem(i,j))) tot++;   	
    	
    	
    	
    	return tot;
    	}
 
    private int contaMovibili(){
    	
int tot=0,st=state;
           	
 
    	
    	 for (int j=0;j<3;j++)
         for (int i=0;i<8;i++)
         if(p[i][j].getState()==st){
         for (int m=0;m<3;m++)
         for (int n=0;n<8;n++)	
         if (isValidMove(i,j,n,m)) tot++;
         }
    	return tot;
    	}
    
    private boolean isMovablexy(int x,int y){
    
    if (!mode) return true;
    	
  	return isMovable(getPuntoIJ(x,y).x,getPuntoIJ(x,y).y);
  	
    	}
 
    public boolean isMovable(int i,int j){
    	 
    if ((!mode)||(is3Pedine())) return true;
    	 
    	 for (int m=0;m<3;m++)
         for (int n=0;n<8;n++)	
         if (isValidMove(i,j,n,m)) return true;
         
    	return false;
    	}
    
    private void invState(){
    	if (state==Punto.BIANCO) state=Punto.NERO;
    	else if (state==Punto.NERO) state=Punto.BIANCO;    	

    	}
    
    public int getState(){
    	return state;}
   
    private boolean isRem(int i,int j){

  if (0!=isPTrig(i,j)) return false;
 
      return true;
    	}

    public boolean getMode(){
    	return mode;}

    private void rem2(int i,int j){
    
    p2[i][j].setState(Punto.VUOTO);
   
 
    }
    
    private void rem1(int i,int j){
     
    p[i][j].setState(Punto.VUOTO);

    }
    
    private void rem(int i,int j){
     
    if (Punto.BIANCO==p[i][j].getState())
    nBianco--;
    if (Punto.NERO==p[i][j].getState())
    nNero--;

    Nrem--;
    
    m.addRemove(i,j,state,mode);
    
    if (Nrem==0){ 
    rem=false;
    invState();
       
    }
    p[i][j].setState(Punto.VUOTO);


if ((!rem)&&(mode)&&(0==contaMovibili())) 
    active=false; 
    
    }
    
   private int isPTrig(int i,int j){
   	
   	int n=0;
   	
   	if (p[i][j].getState()==Punto.VUOTO) return 0;
   	
    if ((i+1)%2==0){
    	
    if (i!=7){
    if ((p[i][j].getState()==p[i+1][j].getState())&&
        (p[i][j].getState()==p[i-1][j].getState()))
        n++;}
    else 
    if ((p[i][j].getState()==p[0][j].getState())&&
        (p[i][j].getState()==p[i-1][j].getState()))
    	n++;
    	
    if ((p[i][0].getState()==p[i][1].getState())&&
        (p[i][0].getState()==p[i][2].getState()))
        n++;
       	
    	}else{
    		
     if (i==0){
     	
   if ((p[i][j].getState()==p[i+1][j].getState())&&
       (p[i][j].getState()==p[i+2][j].getState()))
        n++;
   if ((p[i][j].getState()==p[7][j].getState())&&
       (p[i][j].getState()==p[6][j].getState()))
        n++; 
         	
     	}else if(i==6){
     		
   if ((p[i][j].getState()==p[7][j].getState())&&
       (p[i][j].getState()==p[0][j].getState()))
        n++;
   if ((p[i][j].getState()==p[i-1][j].getState())&&
       (p[i][j].getState()==p[i-2][j].getState()))
        n++;    		
     		}else{
     	
   if ((p[i][j].getState()==p[i+1][j].getState())&&
       (p[i][j].getState()==p[i+2][j].getState()))
        n++;
   if ((p[i][j].getState()==p[i-1][j].getState())&&
       (p[i][j].getState()==p[i-2][j].getState()))
        n++;
      }
    
     }
   	
   	return n;
   	} 
   
   private int checkPunto(int x,int y){
   	   
      for (int j=0;j<3;j++)
      for (int i=0;i<8;i++)
      if ((x<p[i][j].X()+d/2)&&(x>p[i][j].X()-d/2)&&
          (y<p[i][j].Y()+d/2)&&(y>p[i][j].Y()-d/2))
      return p[i][j].getState();
      
  return -1;	
   }

  private Point getPuntoIJ(int x,int y){
   	   
      for (int j=0;j<3;j++)
      for (int i=0;i<8;i++)
      if ((x<p[i][j].X()+d/2)&&(x>p[i][j].X()-d/2)&&
          (y<p[i][j].Y()+d/2)&&(y>p[i][j].Y()-d/2))
      return new Point(i,j);
      
  return null;	
   }

   private int checkPunto2(int x,int y){
   	   
      for (int j=0;j<2;j++)
      for (int i=0;i<9;i++)
      if ((x<p2[i][j].X()+d/2)&&(x>p2[i][j].X()-d/2)&&
          (y<p2[i][j].Y()+d/2)&&(y>p2[i][j].Y()-d/2))
      return p2[i][j].getState();
      
  return -1;	
   }

  private Point getPuntoIJ2(int x,int y){
   	   
      for (int j=0;j<2;j++)
      for (int i=0;i<9;i++)
      if ((x<p2[i][j].X()+d/2)&&(x>p2[i][j].X()-d/2)&&
          (y<p2[i][j].Y()+d/2)&&(y>p2[i][j].Y()-d/2))
      return new Point(i,j);
      
  return null;	
   }

   private void setSelPos(int x,int y){
   	
   
   	
  if (mode){
  	
  	i=getPuntoIJ(x,y).x;
  	j=getPuntoIJ(x,y).y;
  	
  	}else{
  		
  	i=getPuntoIJ2(x,y).x;
  	j=getPuntoIJ2(x,y).y;	
  
  	}
   	
   
   	
   	}
   
   private void remSelPos(){
   	
   	if (mode)
   	   rem1(i,j);
   	 else 
   	   rem2(i,j); 
   	
   	}
  
  
   private void clearSelPos(){
   	i=j=-1;   	
   	}


   private boolean issetSelPos(){
   	if ((i==-1)&&(i==j)) return false;
   	else return true;
   	}

class Mouse implements MouseListener,MouseMotionListener
{  

   public void mouseClicked(MouseEvent event)
   {   
   int st=checkPunto(event.getX(),event.getY());
   
   	   	if (((active)&&(!isPcPlayer())&&(rem)&&(st!=0)&&(st!=-1)&&(st!=state))&&
	isRem(getPuntoIJ(event.getX(),event.getY()).x,
          getPuntoIJ(event.getX(),event.getY()).y))
          {
        rem(getPuntoIJ(event.getX(),event.getY()).x,
            getPuntoIJ(event.getX(),event.getY()).y);
            remI=remJ=-1;
            repaint();
          	}
          	else if (!active){
          		reset();          		
          		}
   	}
    
   public void mouseMoved(MouseEvent event)
   {
   
 
    int st=checkPunto(event.getX(),event.getY());
   	
   	if ((active)&&(!isPcPlayer())&&(rem)&&(st!=0)&&(st!=-1)&&(st!=state)&&
   	    (0==isPTrig(getPuntoIJ(event.getX(),event.getY()).x,getPuntoIJ(event.getX(),event.getY()).y))){
   	remI=getPuntoIJ(event.getX(),event.getY()).x;
   	remJ=getPuntoIJ(event.getX(),event.getY()).y;
 	
   	repaint();
   	}
   	else if ((remI!=-1)||(remJ!=-1)){
   			remI=remJ=-1;
   			repaint();}

  	} 
  
  public void mouseExited(MouseEvent event){} 
  public void mouseEntered(MouseEvent event){} 
  
  public void mouseDragged(MouseEvent event){
   	selP.setPos(event.getX(),event.getY());

   	if ((active)&&(!isPcPlayer())&&(selP.getState()!=Punto.VUOTO))
   	repaint();

  	}
  
  public void mouseReleased(MouseEvent event){
selP.setState(Punto.VUOTO);

if ((active)&&(!isPcPlayer())&&(!rem)&&(checkMove(event.getX(),event.getY()))&&(issetSelPos()))
{    
moveToxy(event.getX(),event.getY());

}
clearSelPos();
repaint();
  	}
  
  public void mousePressed(MouseEvent event){

if ((active)&&(!isPcPlayer())&&(!rem)&&(checkPos(event.getX(),event.getY()))&&(isMovablexy(event.getX(),event.getY()))){
selP.setState(getCol(event.getX(),event.getY()));
selP.setPos(event.getX(),event.getY());
setSelPos(event.getX(),event.getY());
repaint();
}

  	}

}


}