/*
   Tela 1.0: Programma di Tela a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import java.util.Vector;

public class Mosse{
	
	private Vector m;

    public Mosse(){
    	
    	m=new Vector(0,1);    	
    	}	 
	
	public void clear(){
		
		m.clear();
		m.trimToSize();
		}

    public Mossa getLastAndRemove(){
    	
    	if (m.isEmpty()) return null;
    	
    	Mossa last;
    	last=(Mossa) m.remove(m.size()-1);

    	return last;
    	}

    public void addMove(int i,int j,int toi,int toj,int color,boolean mode){
    
    	m.add(new Mossa(i,j,toi,toj,color,mode));
    	
    	}

    public void addRemove(int i,int j,int color,boolean mode){
    	
    	m.add(new Mossa(i,j,color,mode));
    	
    	}

public class Mossa{
	
	public final boolean rem,mode;
	public final int fromI,fromJ,toI,toJ,color;
	
	public Mossa(int i,int j,int color,boolean mode){
		
		this.rem=true;
		this.mode=mode;
		this.fromI=this.toI=i;
		this.fromJ=this.toJ=j;
		this.color=color;
				
		}

	public Mossa(int i,int j,int toi,int toj,int color,boolean mode){
		
		this.rem=false;
		this.mode=mode;
		this.fromI=i;
		this.fromJ=j;
		this.toI=toi;
		this.toJ=toj;
		this.color=color;
				
		}		
	
	
	
	}	
	
	
	}