/*
   Tela 1.0: Programma di Tela a 2 giocatori
   Copyright (C) 2005  Destroyer

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class TelaMenu{
	protected Graph p;
	protected JFrame f;	
	protected JCheckBoxMenuItem mPedine;

	
	public TelaMenu(JFrame f,Graph p){
		
		this.f=f;
		this.p=p;

		}
	
	
	public JMenuBar setMenu(){
		
		
		
    JMenuBar menuBar=new JMenuBar();
    JMenu mTela=new JMenu("Tela");
    JMenuItem mRes=new JMenuItem("Reset");
    JMenuItem mAnn=new JMenuItem("Annulla mossa"); 
    JMenu mOpz=new JMenu("Opzioni di gioco");    
    mPedine=new JCheckBoxMenuItem("usa immagini come pedine");    

    JMenu mHelp=new JMenu("Help");
    JMenuItem mAbt=new JMenuItem("About");

    mPedine.setState(true);
    
    mOpz.add(mPedine);
   menuBar.add(mTela);
    menuBar.add(mHelp);   
	mTela.add(mRes);
	mTela.add(mAnn);
	mTela.add(mOpz);

	mHelp.add(mAbt);
	menuListener l=new menuListener();

	mRes.addActionListener(l);
	mAnn.addActionListener(l);
	mAbt.addActionListener(l);
    mPedine.addActionListener(l);
     
	return menuBar;
		}
	
	
class menuListener implements ActionListener{


	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand().equalsIgnoreCase("reset"))
		{   p.reset();
		   p.repaint();}
		if(e.getActionCommand().equalsIgnoreCase("annulla mossa"))
        {	p.annulla();		
		   p.repaint();}		  

    	if(e.getActionCommand().equalsIgnoreCase("about"))
        {  JDialog d=new JDialog(f,"About Tela",true);
  
           About a=new About(d);
           d.setResizable(false);
     
	       d.setContentPane(a);

	       d.pack();
	   
	   Screen.centraWindow(d);
	   
	       d.show();
               	}
               	
        if(e.getActionCommand().equalsIgnoreCase("usa immagini come pedine"))
        {
        	if (mPedine.getState()){
        	p.imgPedine=true;

        	}else{
        	p.imgPedine=false;

        	}
        	
        	p.repaint();
        	}

		}

	}
	
private class About extends JPanel{
	
	private JDialog d;
	
      
   public About(JDialog d) {
   	this.d=d;

   	setLayout(new GridLayout(2,1));
JPanel panel=new JPanel();

panel.setLayout(new GridLayout(4,1));

JPanel p1=new JPanel();
JPanel p2=new JPanel();

  	JLabel l1=new JLabel("www.xDestroyer.altervista.org",JLabel.CENTER);
   	JLabel l2=new JLabel("Destroyer@email.it",JLabel.CENTER);

   add(new JLabel(new ImageIcon(this.getClass().getResource("logo.jpg")),JLabel.CENTER));


   l1.setForeground(Color.RED);
   l2.setForeground(Color.RED);
   setBackground(Color.black); 
   p1.setBackground(Color.black); 
   p2.setBackground(Color.black);  
   panel.add(l1);
   panel.add(l2);   

      
   JButton ok= new JButton("ok");
   JButton gpl= new JButton("Released under the GNU General Public License");
AboutListener Al=new AboutListener();
ok.addActionListener(Al);
gpl.addActionListener(Al);
ok.setForeground(Color.RED);
gpl.setForeground(Color.RED);
ok.setBackground(Color.BLACK);
gpl.setBackground(Color.BLACK);


p1.add(gpl,JLabel.CENTER);
p2.add(ok,JLabel.CENTER);

panel.add(p1);
panel.add(p2);
panel.setBackground(Color.BLACK);
add(panel);
     }
private class AboutListener implements ActionListener{


	public void actionPerformed(ActionEvent e){
		if(e.getActionCommand().equalsIgnoreCase("ok")){
			
		   d.hide();
			}
		
		if(e.getActionCommand().equalsIgnoreCase("Released under the GNU General Public License")){
			
		  JDialog gpl=new JDialog(d,"GNU General Public License",true);
		  JTextArea text=new JTextArea(30,50);

          JScrollPane scroll=new JScrollPane(text);
          text.setEditable(false);
	
         leggiGPL(text);
         
text.setCaretPosition(0);
text.setFont(new Font("courier new",Font.PLAIN,12));


		  gpl.setContentPane(scroll);
     
          gpl.setResizable(false);
	       gpl.pack();
	       Screen.centraWindow(gpl);

	       gpl.show();	
	       
	}
					
           	
           	}
           	
           	private void leggiGPL(JTextArea t){
           		try{
           		BufferedReader gpl=new BufferedReader(new InputStreamReader(this.getClass().getResourceAsStream("gpl.txt")));	
           		
           		String line;
           		while ((line=gpl.readLine())!=null)
           		t.append(" "+line+"\n");
           		          		
           		gpl.close();	
           		}catch(IOException e){}
           		}
		}
	}	


}